Update Plan
curl --request PUT \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"version": 4503599627370495,
"draft": {
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"appliedTemplateId": "<string>",
"categories": [
{
"workspaceCategoryId": "<string>",
"allocation": {
"mode": "percent",
"value": "<string>"
},
"defaultMarkupPct": "<string>",
"softCostDefaults": {}
}
]
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan"
payload = {
"version": 4503599627370495,
"draft": {
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"appliedTemplateId": "<string>",
"categories": [
{
"workspaceCategoryId": "<string>",
"allocation": {
"mode": "percent",
"value": "<string>"
},
"defaultMarkupPct": "<string>",
"softCostDefaults": {}
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
version: 4503599627370495,
draft: {
manualCeiling: '<string>',
targetMarginPct: '<string>',
contingencyPct: '<string>'
},
appliedTemplateId: '<string>',
categories: [
{
workspaceCategoryId: '<string>',
allocation: {mode: 'percent', value: '<string>'},
defaultMarkupPct: '<string>',
softCostDefaults: {}
}
]
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'version' => 4503599627370495,
'draft' => [
'manualCeiling' => '<string>',
'targetMarginPct' => '<string>',
'contingencyPct' => '<string>'
],
'appliedTemplateId' => '<string>',
'categories' => [
[
'workspaceCategoryId' => '<string>',
'allocation' => [
'mode' => 'percent',
'value' => '<string>'
],
'defaultMarkupPct' => '<string>',
'softCostDefaults' => [
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan"
payload := strings.NewReader("{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"draft": {
"version": 123,
"method": "manual",
"appliedTemplate": {
"id": "<string>",
"name": "<string>",
"differs": true
},
"softCostAllocations": {},
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"derived": {
"softCostBudgets": {},
"ceiling": "<string>",
"profit": "<string>",
"envelope": "<string>",
"contingency": "<string>",
"hard": "<string>",
"allocated": "<string>",
"unallocated": "<string>",
"overAllocated": true,
"areaInputsMissing": true,
"softCostBudgetTotal": "<string>"
},
"areas": [
{
"areaId": "<string>",
"name": "<string>",
"depth": 123,
"isLeaf": true,
"effectiveInstanceCount": 123,
"squareArea": "<string>",
"rate": "<string>",
"manualAmount": "<string>",
"own": "<string>",
"total": "<string>",
"inputMissing": true
}
],
"structureVersion": 123,
"categories": [
{
"workspaceCategoryId": "<string>",
"name": "<string>",
"active": true,
"segmentKey": "<string>",
"segmentName": "<string>",
"departmentId": "<string>",
"departmentName": "<string>",
"itemCount": 123,
"softCostDefaults": {},
"rule": {
"mode": "percent",
"value": "<string>"
},
"allocation": "<string>",
"sharePct": "<string>",
"defaultMarkupPct": "<string>",
"effectiveMarkupPct": "<string>",
"equivalentMarginPct": "<string>",
"markupFromProject": true,
"sellAllocation": "<string>"
}
],
"segments": [
{
"key": "<string>",
"name": "<string>",
"allocated": "<string>"
}
],
"departments": [
{
"id": "<string>",
"name": "<string>",
"segmentKey": "<string>",
"allocated": "<string>"
}
],
"latestVersion": {
"id": "<string>",
"number": 123,
"note": "<string>",
"releasedAt": "2023-11-07T05:31:56Z",
"releasedBy": {
"id": "<string>",
"name": "<string>"
},
"baseDraftVersion": 123,
"baseStructureVersion": 123
},
"hasUnreleasedChanges": true,
"releaseWarnings": [
"CEILING_MISSING"
],
"capabilities": {
"softCosts": true,
"itemizedBudget": true,
"taxInclusive": true,
"allocationTemplates": true
}
}Project Budgets
Update Plan
PUT
/
v1
/
workspaces
/
{workspaceId}
/
projects
/
{projectId}
/
budget
/
plan
Update Plan
curl --request PUT \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"version": 4503599627370495,
"draft": {
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"appliedTemplateId": "<string>",
"categories": [
{
"workspaceCategoryId": "<string>",
"allocation": {
"mode": "percent",
"value": "<string>"
},
"defaultMarkupPct": "<string>",
"softCostDefaults": {}
}
]
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan"
payload = {
"version": 4503599627370495,
"draft": {
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"appliedTemplateId": "<string>",
"categories": [
{
"workspaceCategoryId": "<string>",
"allocation": {
"mode": "percent",
"value": "<string>"
},
"defaultMarkupPct": "<string>",
"softCostDefaults": {}
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
version: 4503599627370495,
draft: {
manualCeiling: '<string>',
targetMarginPct: '<string>',
contingencyPct: '<string>'
},
appliedTemplateId: '<string>',
categories: [
{
workspaceCategoryId: '<string>',
allocation: {mode: 'percent', value: '<string>'},
defaultMarkupPct: '<string>',
softCostDefaults: {}
}
]
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'version' => 4503599627370495,
'draft' => [
'manualCeiling' => '<string>',
'targetMarginPct' => '<string>',
'contingencyPct' => '<string>'
],
'appliedTemplateId' => '<string>',
'categories' => [
[
'workspaceCategoryId' => '<string>',
'allocation' => [
'mode' => 'percent',
'value' => '<string>'
],
'defaultMarkupPct' => '<string>',
'softCostDefaults' => [
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan"
payload := strings.NewReader("{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/plan")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"version\": 4503599627370495,\n \"draft\": {\n \"manualCeiling\": \"<string>\",\n \"targetMarginPct\": \"<string>\",\n \"contingencyPct\": \"<string>\"\n },\n \"appliedTemplateId\": \"<string>\",\n \"categories\": [\n {\n \"workspaceCategoryId\": \"<string>\",\n \"allocation\": {\n \"mode\": \"percent\",\n \"value\": \"<string>\"\n },\n \"defaultMarkupPct\": \"<string>\",\n \"softCostDefaults\": {}\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"draft": {
"version": 123,
"method": "manual",
"appliedTemplate": {
"id": "<string>",
"name": "<string>",
"differs": true
},
"softCostAllocations": {},
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"derived": {
"softCostBudgets": {},
"ceiling": "<string>",
"profit": "<string>",
"envelope": "<string>",
"contingency": "<string>",
"hard": "<string>",
"allocated": "<string>",
"unallocated": "<string>",
"overAllocated": true,
"areaInputsMissing": true,
"softCostBudgetTotal": "<string>"
},
"areas": [
{
"areaId": "<string>",
"name": "<string>",
"depth": 123,
"isLeaf": true,
"effectiveInstanceCount": 123,
"squareArea": "<string>",
"rate": "<string>",
"manualAmount": "<string>",
"own": "<string>",
"total": "<string>",
"inputMissing": true
}
],
"structureVersion": 123,
"categories": [
{
"workspaceCategoryId": "<string>",
"name": "<string>",
"active": true,
"segmentKey": "<string>",
"segmentName": "<string>",
"departmentId": "<string>",
"departmentName": "<string>",
"itemCount": 123,
"softCostDefaults": {},
"rule": {
"mode": "percent",
"value": "<string>"
},
"allocation": "<string>",
"sharePct": "<string>",
"defaultMarkupPct": "<string>",
"effectiveMarkupPct": "<string>",
"equivalentMarginPct": "<string>",
"markupFromProject": true,
"sellAllocation": "<string>"
}
],
"segments": [
{
"key": "<string>",
"name": "<string>",
"allocated": "<string>"
}
],
"departments": [
{
"id": "<string>",
"name": "<string>",
"segmentKey": "<string>",
"allocated": "<string>"
}
],
"latestVersion": {
"id": "<string>",
"number": 123,
"note": "<string>",
"releasedAt": "2023-11-07T05:31:56Z",
"releasedBy": {
"id": "<string>",
"name": "<string>"
},
"baseDraftVersion": 123,
"baseStructureVersion": 123
},
"hasUnreleasedChanges": true,
"releaseWarnings": [
"CEILING_MISSING"
],
"capabilities": {
"softCosts": true,
"itemizedBudget": true,
"taxInclusive": true,
"allocationTemplates": true
}
}Authorizations
Path Parameters
Body
application/json
Response
200 - application/json
⌘I